Subject: Signing certificate - What is that EXACTLY?

From: "Anders Rundgren" <[email-masked]>
Date: Tue, 11 Apr 2006 10:12:39 +0200

Working with an on-line signature standards effort, I have reached to
the point where I unfortunately MUST specify the characteristics of
certificates that can be selected and shown in associated certificate
selection GUIs.

Looking at KU and EKU and a dozen different "real" certificates, I noted
that this algorithm seems to be anything but trivial.  Probably there are
some major real-world CAs who got it all wrong as well. :-(

Here is an attempt based on RFC 3280.  It seems that the designers
of the EKU extension did not foresee any user-signatures except for e-mail.
In a revised RFC 3280 I believe the "id-kp-emailProtection" text could be
a bit more generalized.  Adding a new OID would only make things worse.

No KU or EKU
-----------------
An "all-round" certificate => included

KU only
---------
nonRepudiation   => included

digitalSignature
Now it gets trickier.  If there is a "matching"
certificate with nonRepudiation set, the digitalSignature-
only certificate should presumably NOT be included.
Question: what is "matching" certificate?

EKU only
----------
id-kp-emailProtection => included

KU + EKU
------------
id-kp-emailProtection + KU rules => included

In case there is no working algorithm, I will have to add a request
flag where you can specify "nonConforming" or similar.

thanx
Anders Rundgren